function sample = sampler_update( sample, params )


%% TODO: (1) merge pm and ps, (2) wi on update_states


%% update counter
sample.i = sample.i + 1;

%% update states
[ sample.fn_D, sample.fn_A, sample.sn ] = update_states(sample.pm, sample.ps, ...
                                                        sample.wi_D , sample.wi_A, ...
                                                        sample.ksi_D, sample.ksi_A, ...
                                                        sample.lam_D, sample.lam_A, sample.lam_S, params );

%% update photophysics
[ sample.wi_D, sample.wi_A ] = update_photophysics(sample.fn_D,sample.fn_A,params);
                                                        
%% update transition probablities
[ sample.bm, sample.pm, sample.ps ] = update_transition_probs(sample.sn,sample.bm,params);
                                                        
%% update emission rates and multipliers
[sample.tht,sample.rho_D,sample.rho_A, ...
            sample.kap_D,sample.kap_A,sample.kap_S, sample.rec ] = update_emissions(sample.fn_D,sample.fn_A,sample.sn, ...
                                                                                    sample.rho_D,sample.rho_A, ...
                                                                                    sample.kap_D,sample.kap_A,sample.kap_S, ...
                                                                                    sample.rec, params);

%% update aux variables
[sample.ksi_D,sample.ksi_A, ...
 sample.lam_D,sample.lam_A,sample.lam_S,sample.eff] = update_aux(sample.tht, sample.rho_D,sample.rho_A, ...
                                                                             sample.kap_D,sample.kap_A,sample.kap_S );
                                                


