function [wi_D,wi_A] = update_photophysics(fn_D,fn_A,params)
       
      
%% update donor
idx_D_0 = 1+find(~fn_D(1:end-1));
idx_D_1 = 1+find( fn_D(1:end-1));

wi_D = betarnd(params.wi_D_prior_eta  + [ sum( fn_D(idx_D_0)), sum( fn_D(idx_D_1)),  fn_D(1) ] , ...
               params.wi_D_prior_zeta + [ sum(~fn_D(idx_D_0)), sum(~fn_D(idx_D_1)), ~fn_D(1) ] );


%% update acceptor
idx_A_0 = 1+find(~fn_A(1:end-1));
idx_A_1 = 1+find( fn_A(1:end-1));

wi_A = betarnd(params.wi_A_prior_eta  + [ sum( fn_A(idx_A_0)), sum( fn_A(idx_A_1)),  fn_A(1) ] , ...
               params.wi_A_prior_zeta + [ sum(~fn_A(idx_A_0)), sum(~fn_A(idx_A_1)), ~fn_A(1) ] );

